<?php

function shadow_schema_build_table($table, $columns, $filters) {
  $definition = array(
    'fields' => array(),
    'primary key' => array(),
    'indexes' => array(),
    'module' => 'shadow',
    'name' => $table->db_name,
  );

  if (!$base_table = drupal_get_schema($table->base_table)) {
    return FALSE;
  }

  _shadow_load_classes();
  
  foreach ($columns as $column) {
    $column_parser = new ShadowColumn($column->definition);
    
    $field_schema = $column_parser->getSchema();
    $definition['fields'][$column->db_name] = $field_schema;

    switch ($field_schema['type']) {
      case 'varchar':
        $index_length = max(16, $field_schema['length']);
        break;
      case 'text':
      case 'blob':
        $index_length = NULL;
        break;
      default:
        $index_length = FALSE;
        break;
    }
    if (!is_null($index_length)) {
      
    }
    if (($column_parser->getTableName() == $table->base_table) && in_array($column_parser->getFieldName(), $base_table['primary key'])) {
      $definition['primary key'][] = $column->db_name;
    }
    elseif ($column_parser->isMultiple()) {
      $definition['primary key'][] = $column->db_name;
    }
  }
  
  $definition['indexes'] = array();
  
  return $definition;
}
